
class sprite {
	constructor(image = "placeholder.gif", onclick = null) {
		this.id = null;
		this.image = image;
		this.position = Array();
		this.position.x = 0;
		this.position.y = 0;
		this.element = document.createElement("img");
		this.element.setAttribute('draggable', false);
		this.element.ondragstart = function() { return false; };
		this.element.className = "sprite";
		this.element.onclick = onclick ? onclick.bind(this) : null;
	}
}

class engine {
	constructor() {
		this.screen = document.getElementById("tamagotchi");
		this.sprites = Array();
		this.images = Array();
		this.bars = {
			"hp": document.getElementById("hpbar"),
			"fp": document.getElementById("fpbar")
		};
		this.stacks = document.getElementById("monee");
	}
	frame() {
		this.stacks.innerText = doug.money;
		for (var i = 0; i < this.sprites.length; i++) {
			this.images[i].src = "assets/sprites/"+this.sprites[i].image;
			this.images[i].style.left = this.sprites[i].position.x+"px";
			this.images[i].style.top = this.sprites[i].position.y+"px";
		}
	}
	particle(img, x, y) {
		var sprt = new sprite(img);
		sprt.position.x = x;
		sprt.position.y = y;
		sprt.element.className = "sprite particle";
		this.putSprite(sprt);
		setTimeout(function() {
			this.popSprite(sprt);
		}.bind(this), 1000);
	}
	putSprite(sprite) {
		sprite.element.src = "assets/sprites/"+sprite.image;
		sprite.element.style.left = sprite.position.x+"px";
		sprite.element.style.top = sprite.position.y+"px";
		this.screen.appendChild(sprite.element);
		this.images.push(sprite.element);
		return this.sprites.push(sprite)-1;
	}
	popSprite(sprite) {
		this.screen.removeChild(sprite.element);
		this.sprites.splice(this.sprites.indexOf(sprite), 1);
		this.images.splice(this.images.indexOf(sprite.element), 1);
	}
}
var ngin = new engine();

class tamagotchi {
	constructor() {
		this.RACES = ["stickman"];
		this.STATES = ["idle", "walk_right", "walk_left"];
		this.BASE_Y = ngin.screen.offsetHeight-128-50;
	}
	birth() {
		this.race = this.RACES[Math.floor(Math.random()*this.RACES.length)];
		this.state = "idle";
		this.money = 40; // monkey haha
		this.shits = 0; // B)

		this.sprite = new sprite(this.race+"/"+this.state+".gif", function() {
			ngin.particle("heart.gif", this.position.x, this.position.y);
		});
		this.sprite.position.y = this.BASE_Y;
		this.sprite.position.x = 300;

		this.birth = new Date().getTime();
		this.hp = 100; // Health
		this.fp = 100; // Food

		ngin.putSprite(this.sprite);
	}
	set(data) {
		var stats = JSON.parse(atob(data));
		this.race = stats.race;
		this.birth = stats.birth;
		this.hp = stats.hp;
		this.fp = stats.fp;
		this.money = stats.money;
		this.shits = stats.shits;

		for (var i = this.shits - 1; i >= 0; i--) {
			this.shit(true);
		}

		this.state = "idle";
		this.sprite = new sprite(this.race+"/"+this.state+".gif", function() {
			ngin.particle("heart.gif", this.position.x, this.position.y);
		});
		this.sprite.position.y = this.BASE_Y;
		this.sprite.position.x = 400;
		ngin.putSprite(this.sprite);
	}
	save() {
		var data = {
			"race": this.race,
			"birth": this.birth,
			"hp": this.hp,
			"fp": this.fp,
			"money": this.money,
			"shits": this.shits
		}
		localStorage.savedata = btoa(JSON.stringify(data));
	}
	shit(random = false) {
		var shit = new sprite("shit.gif", function() {
			ngin.popSprite(this);
			doug.money += 5;
			doug.shits -= 1;
			ngin.particle("coin.gif", this.position.x, this.position.y);
		});
		shit.position.x = random ? Math.random() * ngin.screen.offsetWidth - 128 : this.sprite.position.x;
		shit.position.y = this.BASE_Y;
		shit.id = ngin.putSprite(shit);
		if (!random) {
			this.fp = this.fp > 20 ? this.fp-20 : 0;
			this.shits += 1;
		}
	}
	changeState(state) {
		this.state = state;
		this.sprite.image = this.race+"/"+this.state+".gif";
	}
}

var doug = new tamagotchi();

if (!localStorage.savedata || localStorage.savedata == "") {
	doug.birth();
} else {
	doug.set(localStorage.savedata);
}



BOUNDARY_RIGHT = ngin.screen.offsetWidth - 128 - 25;
BOUNDARY_LEFT = 100;

LSD_MOD = 0;

delta = 3;

function gameLoop() {

	ngin.bars.hp.style.width = doug.hp + "%";
	ngin.bars.fp.style.width = doug.fp + "%";

	if (doug.hp <= 0) {
		doug.changeState("dead");
	} else {
		if (Math.random() < 0.1) {
			if (Math.random() < doug.fp/500) {
				doug.shit();
			} else {
				state = doug.STATES[Math.floor(Math.random()*doug.STATES.length)];
				doug.changeState(state);
			}
		}

		if (doug.state == "walk_right") {
			if (doug.sprite.position.x > BOUNDARY_RIGHT) {
				doug.changeState("walk_left");
			} else {
				doug.sprite.position.x += 20;
			}
		}

		if (doug.state == "walk_left") {
			if (doug.sprite.position.x < BOUNDARY_LEFT) {
				doug.changeState("walk_right");
			} else {
				doug.sprite.position.x -= 20;
			}
		}
	}

	if (delta <= 0) {
		delta = 3;
		doug.save();
	} else {
		delta -= 1;
	}
	ngin.frame();

	if (LSD_MOD > 0) {
		LSD_MOD -= 1;
		ngin.screen.className = "fubar";
		setTimeout(gameLoop, 20);
	} else {
		if (doug.hp > 0) {
			doug.hp -= doug.shits * 0.1;
			if (doug.hp < 100) {
				doug.hp += doug.fp / 200;
			}
		}
		ngin.screen.className = "";
		setTimeout(gameLoop, 500);
	}

}

gameLoop();

LSD = 1;
FPP = 2;
HPP = 3;

function action(code) {

	switch (code) {
		case LSD:
			if (doug.money - 10 > 0) {
				ngin.particle("lsd.gif", doug.sprite.position.x, doug.sprite.position.y);
				LSD_MOD = 300;
				doug.money -= 10;
			}
			break;

		case FPP:
			if (doug.money - 1 >= 0) {
				ngin.particle("food.gif", doug.sprite.position.x, doug.sprite.position.y);
				doug.fp = doug.fp < 60 ? doug.fp+40 : 100;
				doug.money -= 1;
			}
			break;

		case HPP:
			if (doug.money - 5 > 0) {
				ngin.particle("health.gif", doug.sprite.position.x, doug.sprite.position.y);
				doug.hp = doug.hp < 80 ? doug.hp+20 : 100;
				doug.money -= 5;
			}
			break;

		default:
			break;
	}
}

